//
//  TextTestView.m
//  TextTest
//
//  Created by Sander Stoks on 2/5/10.
//  Copyright 2010 Curly Brace Publishing. All rights reserved.
//

#import "TextTestView.h"


@implementation TextTestView

- (id)initWithFrame:(NSRect)frame {
    self = [super initWithFrame:frame];
    if (self) {
    }
    return self;
}

#if 1

- (void)drawRect:(NSRect)dirtyRect {
	NSTextStorage* textStorage = [[NSTextStorage alloc] initWithString:@"abcabcabcabcabcabc" attributes:nil];
	NSTextContainer* textContainer = [[[NSTextContainer alloc] initWithContainerSize:NSMakeSize(FLT_MAX, FLT_MAX)] autorelease];
	NSLayoutManager* layoutManager = [[[NSLayoutManager alloc] init] autorelease];
	[layoutManager addTextContainer:textContainer];
	[textStorage addLayoutManager:layoutManager];

	for (int i = 1; i < 24; ++i)
	{
		NSRange glyphRange;
		NSTextContainer* textContainer = [layoutManager textContainerForGlyphAtIndex:0 effectiveRange:&glyphRange];

		[layoutManager drawBackgroundForGlyphRange:glyphRange atPoint:NSMakePoint(0, self.frame.size.height - 6 - 15*i)];
		[layoutManager drawGlyphsForGlyphRange:glyphRange atPoint:NSMakePoint(0, self.frame.size.height - 6 - 15*i)];
		[textStorage replaceCharactersInRange:NSMakeRange([textStorage length], 0) withString:@"."];
	}
}

#else

- (void)drawRect:(NSRect)dirtyRect {
	NSTextStorage* textStorage = [[NSTextStorage alloc] initWithString:@"abcabcabcabcabcabc" attributes:nil];
	NSTextContainer* textContainer = [[[NSTextContainer alloc] initWithContainerSize:NSMakeSize(FLT_MAX, FLT_MAX)] autorelease];
	NSLayoutManager* layoutManager = [[[NSLayoutManager alloc] init] autorelease];
	[layoutManager addTextContainer:textContainer];
	[textStorage addLayoutManager:layoutManager];
	
	NSGraphicsContext* current = [NSGraphicsContext currentContext];
	
	NSSize size = self.frame.size;
	CGLayerRef layer = CGLayerCreateWithContext((CGContextRef)[current graphicsPort], *(CGSize*)&size, NULL);
	NSGraphicsContext *nscontext = [NSGraphicsContext graphicsContextWithGraphicsPort:CGLayerGetContext(layer)
																			  flipped:NO];
	[NSGraphicsContext setCurrentContext:nscontext];

	for (int i = 1; i < 24; ++i)
	{
		NSRange glyphRange;
		NSTextContainer* textContainer = [layoutManager textContainerForGlyphAtIndex:0 effectiveRange:&glyphRange];
		
		[layoutManager drawBackgroundForGlyphRange:glyphRange atPoint:NSMakePoint(0, self.frame.size.height - 6 - 15*i)];
		[layoutManager drawGlyphsForGlyphRange:glyphRange atPoint:NSMakePoint(0, self.frame.size.height - 6 - 15*i)];
		[textStorage replaceCharactersInRange:NSMakeRange([textStorage length], 0) withString:@"."];
	}
	
	[NSGraphicsContext setCurrentContext:current];
	
	CGContextDrawLayerAtPoint((CGContextRef)[current graphicsPort], CGPointMake(0, 0), layer);
	
	CGLayerRelease(layer);
	
	[textStorage release];
}

#endif

@end
